"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-18369
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    set_model_init_error,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.hyperflex_cluster_relationship import HyperflexClusterRelationship
    from intersight.model.hyperflex_data_protection_peer_relationship import HyperflexDataProtectionPeerRelationship
    from intersight.model.hyperflex_hx_host_mount_status_dt import HyperflexHxHostMountStatusDt
    from intersight.model.hyperflex_hx_platform_datastore_config_dt import HyperflexHxPlatformDatastoreConfigDt
    from intersight.model.hyperflex_hx_site_dt import HyperflexHxSiteDt
    globals()['HyperflexClusterRelationship'] = HyperflexClusterRelationship
    globals()['HyperflexDataProtectionPeerRelationship'] = HyperflexDataProtectionPeerRelationship
    globals()['HyperflexHxHostMountStatusDt'] = HyperflexHxHostMountStatusDt
    globals()['HyperflexHxPlatformDatastoreConfigDt'] = HyperflexHxPlatformDatastoreConfigDt
    globals()['HyperflexHxSiteDt'] = HyperflexHxSiteDt


class HyperflexDatastoreStatisticAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'HYPERFLEX.DATASTORESTATISTIC': "hyperflex.DatastoreStatistic",
        },
        ('object_type',): {
            'HYPERFLEX.DATASTORESTATISTIC': "hyperflex.DatastoreStatistic",
        },
        ('accessibility_summary',): {
            'ACCESSIBLE': "ACCESSIBLE",
            'NOT_ACCESSIBLE': "NOT_ACCESSIBLE",
            'PARTIALLY_ACCESSIBLE': "PARTIALLY_ACCESSIBLE",
        },
        ('datastore_kind',): {
            'UNKNOWN': "UNKNOWN",
            'USER_CREATED': "USER_CREATED",
            'INTERNAL': "INTERNAL",
        },
        ('datastore_status',): {
            'NORMAL': "NORMAL",
            'ALERT': "ALERT",
            'FAILED': "FAILED",
        },
        ('mount_summary',): {
            'MOUNTED': "MOUNTED",
            'UNMOUNTED': "UNMOUNTED",
            'MOUNT_FAILURE': "MOUNT_FAILURE",
            'UNMOUNT_FAILURE': "UNMOUNT_FAILURE",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'accessibility_summary': (str,),  # noqa: E501
            'creation_time': (str,),  # noqa: E501
            'datastore_kind': (str,),  # noqa: E501
            'datastore_status': (str,),  # noqa: E501
            'dsconfig': (HyperflexHxPlatformDatastoreConfigDt,),  # noqa: E501
            'free_capacity_in_bytes': (int,),  # noqa: E501
            'host_mount_status': ([HyperflexHxHostMountStatusDt], none_type,),  # noqa: E501
            'is_encrypted': (bool,),  # noqa: E501
            'last_access_time': (str,),  # noqa: E501
            'last_modified_time': (str,),  # noqa: E501
            'mount_summary': (str,),  # noqa: E501
            'parent_uuid': (str,),  # noqa: E501
            'site': (HyperflexHxSiteDt,),  # noqa: E501
            'total_capacity_in_bytes': (int,),  # noqa: E501
            'un_compressed_used_bytes': (int,),  # noqa: E501
            'unshared_used_bytes': (int,),  # noqa: E501
            'uuid': (str,),  # noqa: E501
            'data_protection_peer': (HyperflexDataProtectionPeerRelationship,),  # noqa: E501
            'src_cluster': (HyperflexClusterRelationship,),  # noqa: E501
            'tgt_cluster': (HyperflexClusterRelationship,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'accessibility_summary': 'AccessibilitySummary',  # noqa: E501
        'creation_time': 'CreationTime',  # noqa: E501
        'datastore_kind': 'DatastoreKind',  # noqa: E501
        'datastore_status': 'DatastoreStatus',  # noqa: E501
        'dsconfig': 'Dsconfig',  # noqa: E501
        'free_capacity_in_bytes': 'FreeCapacityInBytes',  # noqa: E501
        'host_mount_status': 'HostMountStatus',  # noqa: E501
        'is_encrypted': 'IsEncrypted',  # noqa: E501
        'last_access_time': 'LastAccessTime',  # noqa: E501
        'last_modified_time': 'LastModifiedTime',  # noqa: E501
        'mount_summary': 'MountSummary',  # noqa: E501
        'parent_uuid': 'ParentUuid',  # noqa: E501
        'site': 'Site',  # noqa: E501
        'total_capacity_in_bytes': 'TotalCapacityInBytes',  # noqa: E501
        'un_compressed_used_bytes': 'UnCompressedUsedBytes',  # noqa: E501
        'unshared_used_bytes': 'UnsharedUsedBytes',  # noqa: E501
        'uuid': 'Uuid',  # noqa: E501
        'data_protection_peer': 'DataProtectionPeer',  # noqa: E501
        'src_cluster': 'SrcCluster',  # noqa: E501
        'tgt_cluster': 'TgtCluster',  # noqa: E501
    }

    read_only_vars = {
        'accessibility_summary',  # noqa: E501
        'creation_time',  # noqa: E501
        'datastore_kind',  # noqa: E501
        'datastore_status',  # noqa: E501
        'free_capacity_in_bytes',  # noqa: E501
        'is_encrypted',  # noqa: E501
        'last_access_time',  # noqa: E501
        'last_modified_time',  # noqa: E501
        'mount_summary',  # noqa: E501
        'parent_uuid',  # noqa: E501
        'total_capacity_in_bytes',  # noqa: E501
        'un_compressed_used_bytes',  # noqa: E501
        'unshared_used_bytes',  # noqa: E501
        'uuid',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """HyperflexDatastoreStatisticAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "hyperflex.DatastoreStatistic", must be one of ["hyperflex.DatastoreStatistic", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "hyperflex.DatastoreStatistic", must be one of ["hyperflex.DatastoreStatistic", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            accessibility_summary (str): HyperFlex datastore accessibility summary. * `ACCESSIBLE` - The HyperFlex Accessibility Summary is Accessible. * `NOT_ACCESSIBLE` - The HyperFlex Accessibility Summary is Not Accessible. * `PARTIALLY_ACCESSIBLE` - The HyperFlex Accessibility Summary is Partially Accessible.. [optional] if omitted the server will use the default value of "ACCESSIBLE"  # noqa: E501
            creation_time (str): Timestamp the datastore object was created.. [optional]  # noqa: E501
            datastore_kind (str): HyperFlex Datastore Kind. * `UNKNOWN` - HyperFlex datastore kind is unknown. * `USER_CREATED` - HyperFlex datastore kind is user created. * `INTERNAL` - HyperFlex datastore kind is internal.. [optional] if omitted the server will use the default value of "UNKNOWN"  # noqa: E501
            datastore_status (str): HyperFlex datastore status. * `NORMAL` - The HyperFlex datastore status is normal. * `ALERT` - The HyperFlex datastore status is alert. * `FAILED` - The HyperFlex datastore status is failed.. [optional] if omitted the server will use the default value of "NORMAL"  # noqa: E501
            dsconfig (HyperflexHxPlatformDatastoreConfigDt): [optional]  # noqa: E501
            free_capacity_in_bytes (int): Free capacity of the datastore in bytes.. [optional]  # noqa: E501
            host_mount_status ([HyperflexHxHostMountStatusDt], none_type): [optional]  # noqa: E501
            is_encrypted (bool): Indicates if the datastore is encrypted or un-encrypted.. [optional]  # noqa: E501
            last_access_time (str): Timestamp the datastore object was last accessed.. [optional]  # noqa: E501
            last_modified_time (str): Timestamp the datastore object was last modified.. [optional]  # noqa: E501
            mount_summary (str): HyperFlex datastore mount summary. * `MOUNTED` - The HyperFlex mount summary is mounted. * `UNMOUNTED` - The HyperFlex mount summary is unmounted. * `MOUNT_FAILURE` - The HyperFlex mount summary is mount failure. * `UNMOUNT_FAILURE` - The HyperFlex mount summary is unmount failure.. [optional] if omitted the server will use the default value of "MOUNTED"  # noqa: E501
            parent_uuid (str): UUID of the parent datastore object.. [optional]  # noqa: E501
            site (HyperflexHxSiteDt): [optional]  # noqa: E501
            total_capacity_in_bytes (int): Total capacity of the datastore object.. [optional]  # noqa: E501
            un_compressed_used_bytes (int): Number of uncompressed used bytes in the datastore.. [optional]  # noqa: E501
            unshared_used_bytes (int): Unshared used capacity of the datastore in bytes.. [optional]  # noqa: E501
            uuid (str): UUID for the datastore object.. [optional]  # noqa: E501
            data_protection_peer (HyperflexDataProtectionPeerRelationship): [optional]  # noqa: E501
            src_cluster (HyperflexClusterRelationship): [optional]  # noqa: E501
            tgt_cluster (HyperflexClusterRelationship): [optional]  # noqa: E501
        """

        class_id = "hyperflex.DatastoreStatistic" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "hyperflex.DatastoreStatistic")
        object_type = "hyperflex.DatastoreStatistic" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "hyperflex.DatastoreStatistic")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """HyperflexDatastoreStatisticAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "hyperflex.DatastoreStatistic", must be one of ["hyperflex.DatastoreStatistic", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "hyperflex.DatastoreStatistic", must be one of ["hyperflex.DatastoreStatistic", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            accessibility_summary (str): HyperFlex datastore accessibility summary. * `ACCESSIBLE` - The HyperFlex Accessibility Summary is Accessible. * `NOT_ACCESSIBLE` - The HyperFlex Accessibility Summary is Not Accessible. * `PARTIALLY_ACCESSIBLE` - The HyperFlex Accessibility Summary is Partially Accessible.. [optional] if omitted the server will use the default value of "ACCESSIBLE"  # noqa: E501
            creation_time (str): Timestamp the datastore object was created.. [optional]  # noqa: E501
            datastore_kind (str): HyperFlex Datastore Kind. * `UNKNOWN` - HyperFlex datastore kind is unknown. * `USER_CREATED` - HyperFlex datastore kind is user created. * `INTERNAL` - HyperFlex datastore kind is internal.. [optional] if omitted the server will use the default value of "UNKNOWN"  # noqa: E501
            datastore_status (str): HyperFlex datastore status. * `NORMAL` - The HyperFlex datastore status is normal. * `ALERT` - The HyperFlex datastore status is alert. * `FAILED` - The HyperFlex datastore status is failed.. [optional] if omitted the server will use the default value of "NORMAL"  # noqa: E501
            dsconfig (HyperflexHxPlatformDatastoreConfigDt): [optional]  # noqa: E501
            free_capacity_in_bytes (int): Free capacity of the datastore in bytes.. [optional]  # noqa: E501
            host_mount_status ([HyperflexHxHostMountStatusDt], none_type): [optional]  # noqa: E501
            is_encrypted (bool): Indicates if the datastore is encrypted or un-encrypted.. [optional]  # noqa: E501
            last_access_time (str): Timestamp the datastore object was last accessed.. [optional]  # noqa: E501
            last_modified_time (str): Timestamp the datastore object was last modified.. [optional]  # noqa: E501
            mount_summary (str): HyperFlex datastore mount summary. * `MOUNTED` - The HyperFlex mount summary is mounted. * `UNMOUNTED` - The HyperFlex mount summary is unmounted. * `MOUNT_FAILURE` - The HyperFlex mount summary is mount failure. * `UNMOUNT_FAILURE` - The HyperFlex mount summary is unmount failure.. [optional] if omitted the server will use the default value of "MOUNTED"  # noqa: E501
            parent_uuid (str): UUID of the parent datastore object.. [optional]  # noqa: E501
            site (HyperflexHxSiteDt): [optional]  # noqa: E501
            total_capacity_in_bytes (int): Total capacity of the datastore object.. [optional]  # noqa: E501
            un_compressed_used_bytes (int): Number of uncompressed used bytes in the datastore.. [optional]  # noqa: E501
            unshared_used_bytes (int): Unshared used capacity of the datastore in bytes.. [optional]  # noqa: E501
            uuid (str): UUID for the datastore object.. [optional]  # noqa: E501
            data_protection_peer (HyperflexDataProtectionPeerRelationship): [optional]  # noqa: E501
            src_cluster (HyperflexClusterRelationship): [optional]  # noqa: E501
            tgt_cluster (HyperflexClusterRelationship): [optional]  # noqa: E501
        """

        class_id = "hyperflex.DatastoreStatistic" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "hyperflex.DatastoreStatistic")
        object_type = "hyperflex.DatastoreStatistic" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "hyperflex.DatastoreStatistic")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name in self.read_only_vars:
                set_model_init_error(f"Warning : {var_name} is omitted from request payload as it is a read-only property")
                continue
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
