"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-18369
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    set_model_init_error,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.display_names import DisplayNames
    from intersight.model.mo_base_mo import MoBaseMo
    from intersight.model.mo_base_mo_relationship import MoBaseMoRelationship
    from intersight.model.mo_tag import MoTag
    from intersight.model.mo_version_context import MoVersionContext
    from intersight.model.storage_net_app_cloud_target_all_of import StorageNetAppCloudTargetAllOf
    from intersight.model.storage_net_app_cluster_relationship import StorageNetAppClusterRelationship
    globals()['DisplayNames'] = DisplayNames
    globals()['MoBaseMo'] = MoBaseMo
    globals()['MoBaseMoRelationship'] = MoBaseMoRelationship
    globals()['MoTag'] = MoTag
    globals()['MoVersionContext'] = MoVersionContext
    globals()['StorageNetAppCloudTargetAllOf'] = StorageNetAppCloudTargetAllOf
    globals()['StorageNetAppClusterRelationship'] = StorageNetAppClusterRelationship


class StorageNetAppCloudTarget(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'STORAGE.NETAPPCLOUDTARGET': "storage.NetAppCloudTarget",
        },
        ('object_type',): {
            'STORAGE.NETAPPCLOUDTARGET': "storage.NetAppCloudTarget",
        },
        ('owner',): {
            'FABRICPOOL': "FabricPool",
            'SNAPMIRROR': "SnapMirror",
        },
        ('provider_type',): {
            'ONTAP_S3': "ONTAP_S3",
            'ALICLOUD': "AliCloud",
            'AWS_S3': "AWS_S3",
            'AZURE_CLOUD': "Azure_Cloud",
            'GOOGLECLOUD': "GoogleCloud",
            'IBM_COS': "IBM_COS",
            'SGWS': "SGWS",
        },
        ('snap_mirror_use',): {
            'DATA': "data",
            'METADATA': "metadata",
        },
    }

    validations = {
        ('uuid',): {
            'regex': {
                'pattern': r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$',  # noqa: E501
            },
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'access_key': (str,),  # noqa: E501
            'authentication_type': (str,),  # noqa: E501
            'azure_account': (str,),  # noqa: E501
            'cap_url': (str,),  # noqa: E501
            'certificate_validation_enabled': (bool,),  # noqa: E501
            'cloud_storage': ([str], none_type,),  # noqa: E501
            'container': (str,),  # noqa: E501
            'ipspace': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'owner': (str,),  # noqa: E501
            'port': (int,),  # noqa: E501
            'provider_type': (str,),  # noqa: E501
            'server': (str,),  # noqa: E501
            'snap_mirror_use': (str,),  # noqa: E501
            'ssl_enabled': (bool,),  # noqa: E501
            'used': (int,),  # noqa: E501
            'uuid': (str,),  # noqa: E501
            'array': (StorageNetAppClusterRelationship,),  # noqa: E501
            'account_moid': (str,),  # noqa: E501
            'create_time': (datetime,),  # noqa: E501
            'domain_group_moid': (str,),  # noqa: E501
            'mod_time': (datetime,),  # noqa: E501
            'moid': (str,),  # noqa: E501
            'owners': ([str], none_type,),  # noqa: E501
            'shared_scope': (str,),  # noqa: E501
            'tags': ([MoTag], none_type,),  # noqa: E501
            'version_context': (MoVersionContext,),  # noqa: E501
            'ancestors': ([MoBaseMoRelationship], none_type,),  # noqa: E501
            'parent': (MoBaseMoRelationship,),  # noqa: E501
            'permission_resources': ([MoBaseMoRelationship], none_type,),  # noqa: E501
            'display_names': (DisplayNames,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        val = {
        }
        if not val:
            return None
        return {'class_id': val}

    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'access_key': 'AccessKey',  # noqa: E501
        'authentication_type': 'AuthenticationType',  # noqa: E501
        'azure_account': 'AzureAccount',  # noqa: E501
        'cap_url': 'CapUrl',  # noqa: E501
        'certificate_validation_enabled': 'CertificateValidationEnabled',  # noqa: E501
        'cloud_storage': 'CloudStorage',  # noqa: E501
        'container': 'Container',  # noqa: E501
        'ipspace': 'Ipspace',  # noqa: E501
        'name': 'Name',  # noqa: E501
        'owner': 'Owner',  # noqa: E501
        'port': 'Port',  # noqa: E501
        'provider_type': 'ProviderType',  # noqa: E501
        'server': 'Server',  # noqa: E501
        'snap_mirror_use': 'SnapMirrorUse',  # noqa: E501
        'ssl_enabled': 'SslEnabled',  # noqa: E501
        'used': 'Used',  # noqa: E501
        'uuid': 'Uuid',  # noqa: E501
        'array': 'Array',  # noqa: E501
        'account_moid': 'AccountMoid',  # noqa: E501
        'create_time': 'CreateTime',  # noqa: E501
        'domain_group_moid': 'DomainGroupMoid',  # noqa: E501
        'mod_time': 'ModTime',  # noqa: E501
        'moid': 'Moid',  # noqa: E501
        'owners': 'Owners',  # noqa: E501
        'shared_scope': 'SharedScope',  # noqa: E501
        'tags': 'Tags',  # noqa: E501
        'version_context': 'VersionContext',  # noqa: E501
        'ancestors': 'Ancestors',  # noqa: E501
        'parent': 'Parent',  # noqa: E501
        'permission_resources': 'PermissionResources',  # noqa: E501
        'display_names': 'DisplayNames',  # noqa: E501
    }

    read_only_vars = {
        'access_key',  # noqa: E501
        'authentication_type',  # noqa: E501
        'azure_account',  # noqa: E501
        'cap_url',  # noqa: E501
        'certificate_validation_enabled',  # noqa: E501
        'container',  # noqa: E501
        'ipspace',  # noqa: E501
        'name',  # noqa: E501
        'owner',  # noqa: E501
        'port',  # noqa: E501
        'provider_type',  # noqa: E501
        'server',  # noqa: E501
        'snap_mirror_use',  # noqa: E501
        'ssl_enabled',  # noqa: E501
        'used',  # noqa: E501
        'uuid',  # noqa: E501
        'account_moid',  # noqa: E501
        'create_time',  # noqa: E501
        'domain_group_moid',  # noqa: E501
        'mod_time',  # noqa: E501
        'shared_scope',  # noqa: E501
        'ancestors',  # noqa: E501
        'permission_resources',  # noqa: E501
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """StorageNetAppCloudTarget - a model defined in OpenAPI

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "storage.NetAppCloudTarget", must be one of ["storage.NetAppCloudTarget", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "storage.NetAppCloudTarget", must be one of ["storage.NetAppCloudTarget", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            access_key (str): Access key ID for AWS_S3 and other S3 compatible provider types.. [optional]  # noqa: E501
            authentication_type (str): Authentication used to access the target.. [optional]  # noqa: E501
            azure_account (str): Azure cloud account name.. [optional]  # noqa: E501
            cap_url (str): Specifies a full URL of the request to a CAP server for retrieving temporary credentials (access-key, secret-password, and session token) for accessing the object store.. [optional]  # noqa: E501
            certificate_validation_enabled (bool): Is SSL/TLS certificate validation enabled? The default value is true. This can only be modified for SGWS, IBM_COS, and ONTAP_S3 provider types.. [optional]  # noqa: E501
            cloud_storage ([str], none_type): [optional]  # noqa: E501
            container (str): Data bucket/container name.. [optional]  # noqa: E501
            ipspace (str): IPspace to use in order to reach the cloud target.. [optional]  # noqa: E501
            name (str): Name of the cloud target.. [optional]  # noqa: E501
            owner (str): Owner of the target. Allowed values are FabricPool or SnapMirror. * `FabricPool` - NetApp FabricPool Cloud Target owner. * `SnapMirror` - NetApp SnapMirror Cloud Target owner.. [optional] if omitted the server will use the default value of "FabricPool"  # noqa: E501
            port (int): Port number of the object store that ONTAP uses when establishing a connection.. [optional]  # noqa: E501
            provider_type (str): Type of cloud provider, e.g., AWS_S3 or ONTAP_S3. * `ONTAP_S3` - Cloud target provider type ONTAP_S3. * `AliCloud` - Cloud target provider type AliCloud. * `AWS_S3` - Cloud target provider type AWS S3. * `Azure_Cloud` - Cloud target provider type Azure_Cloud. * `GoogleCloud` - Cloud target provider type GoogleCloud. * `IBM_COS` - Cloud target provider type IBM_COS. * `SGWS` - Cloud target provider type SGWS.. [optional] if omitted the server will use the default value of "ONTAP_S3"  # noqa: E501
            server (str): Fully qualified domain name of the object store server.. [optional]  # noqa: E501
            snap_mirror_use (str): Use of the cloud target by SnapMirror. * `data` - Data is stored in the SnapMirror target. * `metadata` - Metadata is stored in the SnapMirror target.. [optional] if omitted the server will use the default value of "data"  # noqa: E501
            ssl_enabled (bool): SSL/HTTPS enabled or not.. [optional]  # noqa: E501
            used (int): The amount of cloud space used by all the aggregates attached to the target, in bytes.. [optional]  # noqa: E501
            uuid (str): Uuid of the cloud target.. [optional]  # noqa: E501
            array (StorageNetAppClusterRelationship): [optional]  # noqa: E501
            account_moid (str): The Account ID for this managed object.. [optional]  # noqa: E501
            create_time (datetime): The time when this managed object was created.. [optional]  # noqa: E501
            domain_group_moid (str): The DomainGroup ID for this managed object.. [optional]  # noqa: E501
            mod_time (datetime): The time when this managed object was last modified.. [optional]  # noqa: E501
            moid (str): The unique identifier of this Managed Object instance.. [optional]  # noqa: E501
            owners ([str], none_type): [optional]  # noqa: E501
            shared_scope (str): Intersight provides pre-built workflows, tasks and policies to end users through global catalogs. Objects that are made available through global catalogs are said to have a 'shared' ownership. Shared objects are either made globally available to all end users or restricted to end users based on their license entitlement. Users can use this property to differentiate the scope (global or a specific license tier) to which a shared MO belongs.. [optional]  # noqa: E501
            tags ([MoTag], none_type): [optional]  # noqa: E501
            version_context (MoVersionContext): [optional]  # noqa: E501
            ancestors ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            parent (MoBaseMoRelationship): [optional]  # noqa: E501
            permission_resources ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            display_names (DisplayNames): [optional]  # noqa: E501
        """

        class_id = "storage.NetAppCloudTarget" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "storage.NetAppCloudTarget")
        object_type = "storage.NetAppCloudTarget" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "storage.NetAppCloudTarget")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        required_args = {
            'class_id': class_id,
            'object_type': object_type,
        }
        kwargs.update(required_args)
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]
        composed_keys = set()
        for instance in self._composed_instances:
            composed_keys.update(set(instance.attribute_map.values()))

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            if var_name in composed_keys:
                continue
            setattr(self, var_name, var_value)

        return self


    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """StorageNetAppCloudTarget - a model defined in OpenAPI

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "storage.NetAppCloudTarget", must be one of ["storage.NetAppCloudTarget", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "storage.NetAppCloudTarget", must be one of ["storage.NetAppCloudTarget", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            access_key (str): Access key ID for AWS_S3 and other S3 compatible provider types.. [optional]  # noqa: E501
            authentication_type (str): Authentication used to access the target.. [optional]  # noqa: E501
            azure_account (str): Azure cloud account name.. [optional]  # noqa: E501
            cap_url (str): Specifies a full URL of the request to a CAP server for retrieving temporary credentials (access-key, secret-password, and session token) for accessing the object store.. [optional]  # noqa: E501
            certificate_validation_enabled (bool): Is SSL/TLS certificate validation enabled? The default value is true. This can only be modified for SGWS, IBM_COS, and ONTAP_S3 provider types.. [optional]  # noqa: E501
            cloud_storage ([str], none_type): [optional]  # noqa: E501
            container (str): Data bucket/container name.. [optional]  # noqa: E501
            ipspace (str): IPspace to use in order to reach the cloud target.. [optional]  # noqa: E501
            name (str): Name of the cloud target.. [optional]  # noqa: E501
            owner (str): Owner of the target. Allowed values are FabricPool or SnapMirror. * `FabricPool` - NetApp FabricPool Cloud Target owner. * `SnapMirror` - NetApp SnapMirror Cloud Target owner.. [optional] if omitted the server will use the default value of "FabricPool"  # noqa: E501
            port (int): Port number of the object store that ONTAP uses when establishing a connection.. [optional]  # noqa: E501
            provider_type (str): Type of cloud provider, e.g., AWS_S3 or ONTAP_S3. * `ONTAP_S3` - Cloud target provider type ONTAP_S3. * `AliCloud` - Cloud target provider type AliCloud. * `AWS_S3` - Cloud target provider type AWS S3. * `Azure_Cloud` - Cloud target provider type Azure_Cloud. * `GoogleCloud` - Cloud target provider type GoogleCloud. * `IBM_COS` - Cloud target provider type IBM_COS. * `SGWS` - Cloud target provider type SGWS.. [optional] if omitted the server will use the default value of "ONTAP_S3"  # noqa: E501
            server (str): Fully qualified domain name of the object store server.. [optional]  # noqa: E501
            snap_mirror_use (str): Use of the cloud target by SnapMirror. * `data` - Data is stored in the SnapMirror target. * `metadata` - Metadata is stored in the SnapMirror target.. [optional] if omitted the server will use the default value of "data"  # noqa: E501
            ssl_enabled (bool): SSL/HTTPS enabled or not.. [optional]  # noqa: E501
            used (int): The amount of cloud space used by all the aggregates attached to the target, in bytes.. [optional]  # noqa: E501
            uuid (str): Uuid of the cloud target.. [optional]  # noqa: E501
            array (StorageNetAppClusterRelationship): [optional]  # noqa: E501
            account_moid (str): The Account ID for this managed object.. [optional]  # noqa: E501
            create_time (datetime): The time when this managed object was created.. [optional]  # noqa: E501
            domain_group_moid (str): The DomainGroup ID for this managed object.. [optional]  # noqa: E501
            mod_time (datetime): The time when this managed object was last modified.. [optional]  # noqa: E501
            moid (str): The unique identifier of this Managed Object instance.. [optional]  # noqa: E501
            owners ([str], none_type): [optional]  # noqa: E501
            shared_scope (str): Intersight provides pre-built workflows, tasks and policies to end users through global catalogs. Objects that are made available through global catalogs are said to have a 'shared' ownership. Shared objects are either made globally available to all end users or restricted to end users based on their license entitlement. Users can use this property to differentiate the scope (global or a specific license tier) to which a shared MO belongs.. [optional]  # noqa: E501
            tags ([MoTag], none_type): [optional]  # noqa: E501
            version_context (MoVersionContext): [optional]  # noqa: E501
            ancestors ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            parent (MoBaseMoRelationship): [optional]  # noqa: E501
            permission_resources ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            display_names (DisplayNames): [optional]  # noqa: E501
        """

        class_id = "storage.NetAppCloudTarget" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "storage.NetAppCloudTarget")
        object_type = "storage.NetAppCloudTarget" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "storage.NetAppCloudTarget")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        required_args = {
            'class_id': class_id,
            'object_type': object_type,
        }
        kwargs.update(required_args)
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in self.read_only_vars:
                set_model_init_error(f"Warning : {var_name} is omitted from request payload as it is a read-only property")
                continue
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              MoBaseMo,
              StorageNetAppCloudTargetAllOf,
          ],
          'oneOf': [
          ],
        }
